#include <iostream>
#include <math.h>
#include "polynomial.h"
#include "../image.h"

using namespace std;

///////////////////////////////////------------Class: CRow------------/////////////////////////////////

CRow::CRow (int len)
	{
		//cout << "CRow::CRow (int len)" << endl;;
		length = len;
			for (int i = 0; i < length; i++)
				coefs.push_back (0);
	};

/*CRow::CRow (const CRow &row)
	{
		//cout << "CRow::CRow (const CRow &row)
" << endl;;
		vector<long double>::iterator it;
		for (it=coefs.begin(); it!=coefs.end(); ++it)
		{
			cout << "dabar pushins " << i << " - taji elementa...";
			coefs.push_back (*it);
			cout << "Done." << endl;;
		}
	};
*/

CRow::~CRow ()
	{
		//cout << "CRow::~CRow ()" << endl;;
	};

int CRow::getlen ()
    {
    	//cout << "int CRow::getlen ()" << endl;;
	return length;
    };

void CRow::print ()
	{
		//cout << "void CRow::print ()" << endl;;
		for (int i = 0; i < length; i++)
			cout << member (i) << " ";
	};

long double& CRow::member (int index)
	{
		//cout << "long double& CRow::member (int index)" << endl;;
		return coefs [index];
	};

/////////////////////////////////------------Class: CEquation------------/////////////////////////////////

CEquation::CEquation (int len, long double res): CRow (len)
	{
		//cout << "CEquation::CEquation (int len, long double res): CRow (len)" << endl;;
		result = res;
	};

/*CEquation::CEquation (const CEquation &equ): CRow (equ)
	{
		//cout << "CEquation::CEquation (const CEquation &equ): CRow (equ)" << endl;;
		result = equ.result;
	};
*/

CEquation::~CEquation ()
	{
		//cout << "CEquation::~CEquation ()" << endl;;
//nieko cia nereikia
	};

void CEquation::setresult (const long double res)
	{
		//cout << "void CEquation::setresult (const long double res)" << endl;;
		result = res;
	};

long double CEquation::getresult ()
	{
		//cout << "long double CEquation::getresult ()" << endl;;
		return result;
	};

void CEquation::print ()
	{
		//cout << "void CEquation::print ()" << endl;;
			for (int i = 0; i < length; i++)
				cout << " + " << coefs [i] << " * a" << i;
		cout << " = " << result;
	};

void CEquation::setcoefs (long double x)
	{
		//cout << "void CEquation::setcoefs (long double x)" << endl;;
		for (int i = 0; i < length; i++)
			coefs [i] = x;
	};

void CEquation::add (CEquation& equ)
	{
		//cout << "void CEquation::add (CEquation& equ)" << endl;;
		int len;
			if (length > equ.length)
				len = length;
			else
				len = equ.length;
		vector<long double> tmpcoefs;
			for (int i = 0; i < len; i++)
				{
					if (i < length)
						tmpcoefs.push_back (member (i));
					else
						tmpcoefs.push_back (0);
					if (i < equ.length)
						tmpcoefs [i] += equ.member (i);
				};
		result += equ.result;
		coefs = tmpcoefs;
		length = len;
	};

void CEquation::sub (CEquation& equ)
	{
		//cout << "void CEquation::sub (CEquation& equ)" << endl;;
		int len;
			if (length > equ.length)
				len = length;
			else
				len = equ.length;
		vector<long double> tmpcoefs;
			for (int i = 0; i < len; i++)
				{
					if (i < length)
						tmpcoefs.push_back (coefs [i]);
					else
						tmpcoefs.push_back (0);
					if (i < equ.length)
						tmpcoefs [i] -= equ.member (i);
				};
		result -= equ.result;
		coefs = tmpcoefs;
		length = len;
	};

void CEquation::mul (const long double scalar)
	{
		//cout << "void CEquation::mul (const long double scalar)" << endl;;
			for (int i = 0; i < length; i++)
				coefs [i] *= scalar;
		result *= scalar;
	};

void CEquation::div (const long double scalar)
	{
		//cout << "void CEquation::div (const long double scalar)" << endl;;
			for (int i = 0; i < length; i++)
				coefs [i] /= scalar;
		result /= scalar;
	};

///////////////////////////////////------------Class: CPolynomial------------/////////////////////////////////

void CPolynomial::calculate (long double value)
	{
		//cout << "void CPolynomial::calculate (long double value)" << endl;;
		for (int i = 0; i < length; i++)
			coefs [i] = powl (value, i);
//			coefs [i] = plowl (value, i);
	};

void CPolynomial::calcdiff (long double value)
	{
		//cout << "void CPolynomial::calcdiff (long double value)" << endl;;
		//cout << "coefs.size () = " << coefs.size () << endl;
		coefs [0] = 0;
			for (int i = 1; i < length; i++)
				coefs [i] = i * powl (value, i - 1);
//				coefs [i] = i * plowl (value, i - 1);
	};

double CPolynomial::get_value (double x)
	{
		//cout << "double CPolynomial::get_value (double x)" << endl;;
		long double value = 0;
			for (int i = 0; i < length; i++)
				{
//					//cout << "coefs [" << i << "] = " << coefs [i] << "; powl (" << x << ", " << i << ") = " << powl (x, i) << endl;
					value += coefs [i] * powl (x, i);
//					result += plowl (x, i, coefs [i]);
				};
			if (value > 1)
				value = 1;
			if (value < 0)
				value = 0;
		return value;
	};

void CPolynomial::print ()
	{
		//cout << "void CPolynomial::print ()" << endl;;
			for (int i = length - 1; i >= 0; i--)
				cout << " + " << coefs [i] << "*x^" << i;
		cout << " = " << result << endl;
	};

void CPolynomial::pmul (CPolynomial &poly)
	{
		//cout << "void CPolynomial::pmul (const CPolynomial &poly)" << endl;
		int len = length + poly.length - 1;
		vector<long double> tmpcoefs;
			for (int i = 0; i < len; i++)
				{
					tmpcoefs.push_back (0);
						for (int s = 0; s <= i; s++)
							if ((s < length) && (i - s < poly.length))
								tmpcoefs [i] += member (s) * poly.member (i - s);
				};
		coefs = tmpcoefs;
		length = len;
		result *= poly.getresult ();
	};

///////////////////////////////////------------Class: CMatrix------------/////////////////////////////////


CMatrix::CMatrix ()
	{
		//cout << "CMatrix::CMatrix ()" << endl;;
		dimension = 0;
	};

CMatrix::CMatrix (int dim)
	{
		//cout << "CMatrix::CMatrix (int dim)" << endl;;
		dimension = dim;
			for (int i = 0; i < dimension; i++)
				{
					CPolynomial poly (dimension);
					//cout << "dabar pushins " << i << " - taji polinoma...";
					rows.push_back (poly);
					//cout << "Done." << endl;;
				};
	};

CMatrix::~CMatrix ()
	{
		//cout << "CMatrix::~CMatrix ()" << endl;;
	};

void CMatrix::swaprows (int i, int j)
	{
		//cout << "void CMatrix::swaprows (int i, int j)" << endl;;
		CPolynomial temp;
		temp = rows [i];
			for (int k = 0; k < dimension; k++)
				{
					rows [i].member (k) = rows [j].member (k);
					rows [j].member (k) = temp.member (k);
				};
		rows [i].setresult (rows [j].getresult ());
		rows [j].setresult (temp.getresult ());
	};

void CMatrix::gausselim ()
	{
		//cout << "void CMatrix::gausselim ()" << endl;;
			for (int i = 0; i < dimension; i++)
				{
					int j = i;
						while ((member (j).member (dimension - 1 - i) == 0) && (j < dimension - 1))
							j++;
						if (i != j)
							swaprows (i, j);
						if (member (i).member (dimension - 1 - i) != 0)
							{
									if (member (i).member (dimension - 1 - i) != 1)
										member (i).div (member (i).member (dimension - 1 - i));
									for (int k = i + 1; k < dimension; k++)
										if (member (k).member (dimension - 1 - i) != 0)
											{
												member (k).div (member (k).member (dimension - 1 - i));
												member (k).sub (member (i))
;
											};
							};
				};
			for (int i = dimension - 2; i >= 0; i--)
				for (int j = dimension - 1; j > i; j--)
					{
						CPolynomial tmp  = member (j);
						long double bu = member (i).member (dimension - 1 - j);
						tmp.mul (bu);
						member (i).sub (tmp);
					};
	};

vector<long double> CMatrix::getresults ()
	{
		//cout << "vector<long double> CMatrix::getresults ()" << endl;;
		vector<long double> results;
			for (int i = 0; i < dimension; i++)
				results.push_back (rows [dimension - 1 - i].getresult ());
		return results;
	};

void CMatrix::print ()
	{
		//cout << "void CMatrix::print ()" << endl;;
		for (int i = 0; i < dimension; i++)
			rows [i].print ();
	};

CPolynomial& CMatrix::member (int index)
	{
		//cout << "CPolynomial& CMatrix::member (int index)" << endl;;
		return rows [index];
	};


long double plowe (long double *buf, int len, const long double *bla)
	{
		if (len == 1)
			return buf [0];
		else
			return plowe (buf + len / 2, len - len / 2, bla) * plowe (buf, len / 2, bla);
	};

long double plowl (long double x, int power, long double bla)
	{
			if (power == 0)
				return bla;
			if (x == 1)
				return bla;
			if (x == 0)
				return 0;
		long double *buf = new long double [power + 1];
			for (int i = 0; i < power; i++)
				buf [i] = x;
		buf [power] = bla;
		long double result = plowe (buf, power + 1, buf);
		delete[] buf;
		return result;
	};

///////////////////////////////////------------Class: CPolyInt------------/////////////////////////////////

CPolyInt::CPolyInt (SLayer &l, int scanln, bool isVert, int start, int len)
	{
		//cout << "CPolyInt::CPolyInt (double *buffer, int count)";
		construct (l, scanln, isVert, start, len);
	};

void CPolyInt::construct (SLayer &l, int scanln, bool isVert, int start, int len)
	{
			if (len == -1)
				if (isVert)
					numofpoints = l.h;
				else
					numofpoints = l.w;
			else
				numofpoints = len;
		length = numofpoints;
		CMatrix matrix (length);
			for (int i = 0; i < numofpoints; i++)
				{
					matrix.member (i).calculate ((long double)i/numofpoints);
						if (isVert)
							matrix.member (i).setresult (l.data [scanln][i + start]);
						else
							matrix.member (i).setresult (l.data [i + start][scanln]);
				};
		matrix.gausselim ();
		coefs = matrix.getresults ();
		result = 0;
	};

///////////////////////////////////------------Class: CAdvPolyInt------------/////////////////////////////////

CAdvPolyInt::CAdvPolyInt (SLayer &l, int scanln, bool isVert, int start, int len)
	{
		//cout << "CAdvPolyInt::CAdvPolyInt" << endl;;
		construct (l, scanln, isVert, start, len);
	};

void CAdvPolyInt::construct (SLayer &l, int scanln, bool isVert, int start, int len)
	{
			if (len == -1)
				if (isVert)
					numofpoints = l.h;
				else
					numofpoints = l.w;
			else
				numofpoints = len;
		length = numofpoints + 2;
		CMatrix matrix (length);
		matrix.member (numofpoints).setcoefs (0.0);
		matrix.member (numofpoints + 1).setcoefs (0.0);
			for (int i = 0; i < numofpoints; i++)
				{
					CPolynomial diff (length);
					matrix.member (i).calculate ((long double)i/numofpoints);
						if (isVert)
							matrix.member (i).setresult (l.data [scanln][i + start]);
						else
							matrix.member (i).setresult (l.data [i + start][scanln]);
					diff.calcdiff ((long double)i/numofpoints);
					diff.setresult (0.0);
					matrix.member (numofpoints + i % 2).add (diff);
				};
		matrix.gausselim ();
		coefs = matrix.getresults ();
		result = 0;
	};

///////////////////////////////////------------Class: CLagrangeInt------------/////////////////////////////////

CLagrangeInt::CLagrangeInt (SLayer &l, int scanln, bool isVert, int start, int len)
	{
		//cout << "CLagrangeInt::CLagrangeInt (double *buffer, int count): CPolynomial ()" << endl;;
		construct (l, scanln, isVert, start, len);
	};

void CLagrangeInt::construct (SLayer &l, int scanln, bool isVert, int start, int len)
	{
			if (len == -1)
				if (isVert)
					numofpoints = l.h;
				else
					numofpoints = l.w;
			else
				numofpoints = len;
			for (int i = 0; i < numofpoints; i++)
				{
					long double bottom = 1;
					CPolynomial poly (1);
					poly.member (0) = 1;
						for (int j = 0; j < numofpoints; j++)
							{
								CPolynomial bipoly (2);
								bipoly.member (0) = -(long double)j/numofpoints;
								bipoly.member (1) = 1;
									if (i != j)
										{
											poly.pmul (bipoly);
											bottom *= ((long double)i - j)/numofpoints;
										};
							};
						if (isVert)
							poly.mul (l.data [scanln][i + start]/bottom);
						else
							poly.mul (l.data [i + start][scanln]/bottom);
					add (poly);
				};
		result = 0;
	};

////////////////////////// (= METODAI =) /////////////////////////////

bool CPolyMethod::processlayer (SLayer &dest, SLayer &src)
	{
		SLayer layer (src.w, dest.h);
			for (int x = 0; x < src.w; x++)
				{
					CPolyInt poly (src, x, true);
						for (int y = 0; y < dest.h; y++)
							layer.data [x][y] = poly.get_value ((double) y / dest.h);
					cout << '.' << flush;
				};
			for (int y = 0; y < dest.h; y++)
				{
					CPolyInt poly (layer, y, false);
						for (int x = 0; x < dest.w; x++)
							dest.data [x][y] = poly.get_value ((double) x / dest.w);
					cout << '.' << flush;
				};
	};

bool CPolyMethod::process (CImage &dest, CImage &src)
	{
		cout << "Polynomial Interpolation" << endl;
		cout << "Processing Red Layer" << flush;
		processlayer (dest.getR (), src.getR ()); cout << "Done." << endl;
		cout << "Processing Green Layer" << flush;
		processlayer (dest.getG (), src.getG ()); cout << "Done." << endl;
		cout << "Processing Blue Layer" << flush;
		processlayer (dest.getB (), src.getB ()); cout << "Done." << endl;
		return true;
	};

bool CAdvPolyMethod::processlayer (SLayer &dest, SLayer &src)
	{
		SLayer layer (src.w, dest.h);
			for (int x = 0; x < src.w; x++)
				{
					CAdvPolyInt poly (src, x, true);
						for (int y = 0; y < dest.h; y++)
							layer.data [x][y] = poly.get_value ((double) y / dest.h);
					cout << '.' << flush;
				};
			for (int y = 0; y < dest.h; y++)
				{
					CAdvPolyInt poly (layer, y, false);
						for (int x = 0; x < dest.w; x++)
							dest.data [x][y] = poly.get_value ((double) x / dest.w);
					cout << '.' << flush;
				};
	};


bool CAdvPolyMethod::process (CImage &dest, CImage &src)
	{
		cout << "Advanced Polynomial Interpolation" << endl;
		cout << "Processing Red Layer" << flush;
		processlayer (dest.getR (), src.getR ()); cout << "Done." << endl;
		cout << "Processing Green Layer" << flush;
		processlayer (dest.getG (), src.getG ()); cout << "Done." << endl;
		cout << "Processing Blue Layer" << flush;
		processlayer (dest.getB (), src.getB ()); cout << "Done." << endl;
		return true;
	};

bool CLagrangeMethod::processlayer (SLayer &dest, SLayer &src)
	{
		SLayer layer (src.w, dest.h);
			for (int x = 0; x < src.w; x++)
				{
					CLagrangeInt poly (src, x, true);
						for (int y = 0; y < dest.h; y++)
							layer.data [x][y] = poly.get_value ((double) y / dest.h);
					cout << '.' << flush;
				};
			for (int y = 0; y < dest.h; y++)
				{
					CLagrangeInt poly (layer, y, false);
						for (int x = 0; x < dest.w; x++)
							dest.data [x][y] = poly.get_value ((double) x / dest.w);
					cout << '.' << flush;
				};
	};


bool CLagrangeMethod::process (CImage &dest, CImage &src)
	{
		cout << "Lagrange Interpolation" << endl;
		cout << "Processing Red Layer" << flush;
		processlayer (dest.getR (), src.getR ()); cout << "Done." << endl;
		cout << "Processing Green Layer" << flush;
		processlayer (dest.getG (), src.getG ()); cout << "Done." << endl;
		cout << "Processing Blue Layer" << flush;
		processlayer (dest.getB (), src.getB ()); cout << "Done." << endl;
		return true;
	};

