
#include <math.h>
#include <iostream>

using namespace std;

#include "curves_cub.h"
#include <malloc.h>
#include "../mmgr.h"

ccurve_cub_2d::ccurve_cub_2d()
{
	buf = 0;
	bufsize = 0;
}

ccurve_cub_2d::ccurve_cub_2d(SLayer &l, int scanln, bool isVert)
{
	construct(l, scanln, isVert);
}

ccurve_cub_2d::~ccurve_cub_2d()
{
	destruct();
}

void
ccurve_cub_2d::construct(SLayer &l, int scanln, bool isVert)
{
	if (isVert)
	{
		bufsize = l.w;
		buf = new (double)[bufsize];
		for (int x=0; x<bufsize; x++) buf[x] = l.data[x][scanln];
	}
	else
	{
		bufsize = l.h;
		buf = new (double)[bufsize];
		for (int y=0; y<bufsize; y++) buf[y] = l.data[scanln][y];
	}
}

void
ccurve_cub_2d::destruct()
{
	if (buf) delete[] buf;
	buf = 0;
	bufsize = 0;
}

double
ccurve_cub_2d::get_value (double x)
{
//	if (x==1.0f) return buf[bufsize-1];
	x*=bufsize-2;
	int pos = (int)(x);
	x=x-pos;

	double a;
	double b = buf[pos];
	double c = buf[pos+1];
	double d;

	if (pos==0) a = b;
	    else a = buf[pos-1];
	if (pos+2 > bufsize) d = c;
	    else d = buf[pos+2];

	double p = (d - c) - (a - b);
        double q = (a - b) - p;
	double r = c - a;
	double s = b;
	double rez = p * (x * x * x) + q * (x * x) + r * x + s;
	if (rez > 1.0) rez = 1.0;
	if (rez < 0.0) rez = 0.0;
/*	cout << "pos "<< pos << endl;
	cout << "A   " << a << endl;
	cout << "B   " << b << endl;
	cout << "xxx " << rez << endl;
	cout << "C   " << c << endl;
	cout << "D   " << d << endl;
	char blah;
	cin >> blah;/*/
	return rez;
}



