
#ifdef DYRKI_WIN32
#include <strings.h>
#elif defined DYRKI_LINUX
#include <string.h>
#endif
#include <stdlib.h>		// atof
#include <stdio.h>		// printf: DEBUG

#include "allegro_hack.h"

#include "mmgr.h"

#include "gui.h"
#include "application.h"
#include "image.h"
#include "utils.h"

#ifdef DYRKI_EXT_VIEW
#include "externView.h"
#endif


static int file_open_proc ();
static int file_exit_proc ();
static int file_save_proc ();
static int file_saveas_proc ();

static int about_proc ();

static int d_refresh_button_proc (int msg, DIALOG *d, int c);

static void drawSource ();
static void drawDestination ();

int method00_menu_proc ();
int method01_menu_proc ();
int method02_menu_proc ();
int method03_menu_proc ();
int method04_menu_proc ();
int method05_menu_proc ();
int method06_menu_proc ();
int method07_menu_proc ();
int method08_menu_proc ();
int method09_menu_proc ();
int method10_menu_proc ();
int method11_menu_proc ();
int method12_menu_proc ();
int method13_menu_proc ();
int method14_menu_proc ();
int method15_menu_proc ();
int method16_menu_proc ();
int method17_menu_proc ();
int method18_menu_proc ();
int method19_menu_proc ();
int method20_menu_proc ();

static ALLEGRO_BITMAP	*g_SrcImage = 0;
static ALLEGRO_BITMAP	*g_DestImage = 0;
static char 		g_src_fname[1024];
static char 		g_dst_fname[1024];
static char 		g_ScaleString[33];
static bool		gSavedOnce = false;
static MENU		*g_MethodsMenu;



struct CGui::SImpl
{
	DIALOG			*m_Dialog;
	MENU			*m_MainMenu;
	MENU			*m_FileMenu;
	MENU			*m_MethodsMenu;
	char			*src_fname;
};


CGui::CGui ()
{
	impl = new SImpl ();

	memset (g_src_fname, 0, 1024);
	impl->src_fname = g_src_fname;

	gui_fg_color = makecol (0, 0, 0);
	gui_mg_color = makecol (85, 85, 85);
	gui_bg_color = makecol (128, 128, 128);

	printf ("CGui ()\n");
}


CGui::~CGui ()
{
	delete[] impl->m_FileMenu;
	delete[] impl->m_MainMenu;
	delete[] impl->m_MethodsMenu;
	delete[] impl->m_Dialog;
	delete impl;

	if (0 != g_SrcImage)
		destroy_bitmap (g_SrcImage);

	if (0 != g_DestImage)
		destroy_bitmap (g_DestImage);

	printf ("~CGui ()\n");
}


int CGui::doDialog ()
{
	do_dialog (impl->m_Dialog, -1);

	return 0;
}



/*
==================================================================
	Some static callback functions needed for Allegro's GUI
==================================================================
*/



static int file_open_proc ()
{
	RGB	pal[256];

	CApplication::getInstance ().getCwd (g_src_fname);
	if (0 != file_select_ex ("Select a file", g_src_fname, "PCX;BMP;TGA;LBM", 1023, OLD_FILESEL_WIDTH, OLD_FILESEL_HEIGHT))
	{
		if (0 == g_SrcImage)
		{
			destroy_bitmap (g_SrcImage);
			g_SrcImage = 0;
		}

		set_color_depth (32);
		set_color_conversion (COLORCONV_TOTAL);
		set_color_depth (32);
		g_SrcImage = load_bitmap (g_src_fname, pal);
		drawSource ();
	}

	return D_REDRAW;
}


static int file_exit_proc ()
{
	return D_CLOSE;
}


static int file_save_proc ()
{
	if (!gSavedOnce)
		return file_saveas_proc ();

	PALETTE pal;
	get_palette (pal);
	save_bitmap (g_dst_fname, g_DestImage, pal);

	return D_REDRAW;
}

static int file_saveas_proc ()
{
	CApplication::getInstance ().getCwd (g_dst_fname);
	if (0 != file_select_ex ("Save as...", g_dst_fname, "PCX;BMP;TGA;LBM", 1023, OLD_FILESEL_WIDTH, OLD_FILESEL_HEIGHT))
	{
		if (0 == g_DestImage)
		{
			alert ("Sorry,", "No destination image yet.", "Run some method first", "OK", 0, 13, 27);
			return D_REDRAW;
		}

		PALETTE pal;
		get_palette (pal);
		save_bitmap (g_dst_fname, g_DestImage, pal);
	}

	gSavedOnce = true;

	return D_REDRAW;
}


static int about_proc ()
{
//	alert3 ("This is how we do it ;)", 0, 0, "OK", 0, 0, 13, 13, 27);
	alert3 ("The image zooming research project \"Dyrki\"",
		"Version 1.0.0, build 1",
//		"written by: Robertas Dumpis, Ignas Mikalajunas, Laurynas Ruskys, Justas Sadzevicius and Vytautas Shaltenis",
		"written by the Igrovod team",
		"OK", 0, 0, 13, 13 , 27);

	return D_REDRAW;
}


static int d_refresh_button_proc (int msg, DIALOG *d, int c)
{
	int	ret;

	ret = d_button_proc (msg, d, c);

	if (D_CLOSE == ret)
	{
		int	selectedMethod = -1;

		for (int i=0; 0!=g_MethodsMenu[i].text; i++)
		{
			if (D_SELECTED == g_MethodsMenu[i].flags)
			{
				selectedMethod = i;
				break;
			}
		}

		if (-1 == selectedMethod)
		{
			alert ("Error!", "Something is very bad with", "method selection!", "OK", 0, 13, 27);
			return D_REDRAW;
		}

		// TODO: create destination bitmap here
		// FIXME: or maybe not? destination bitmap should be created from destiation CImage after the method does its job

		// TODO
		// something is bad here with source and destination images.
		// something should be altered
		// FIXME: never ever write so abstract TODOs any more :)
		if (CApplication::getInstance ().runMethod (selectedMethod))
		{
			drawDestination ();
		}

		return D_REDRAW;
	}

	return ret;
}



void CGui::initMenus ()
{
	impl->m_FileMenu = new MENU[5];
	for (int i=0; i<5; i++)
	{
		impl->m_FileMenu[i].text = 0;
		impl->m_FileMenu[i].proc = 0;
		impl->m_FileMenu[i].child = 0;
		impl->m_FileMenu[i].flags = 0;
		impl->m_FileMenu[i].dp = 0;
	}
	impl->m_FileMenu[0].text = "&Open...\tF3";
	impl->m_FileMenu[0].proc = file_open_proc;
	impl->m_FileMenu[1].text = "&Save\tF2";
	impl->m_FileMenu[1].proc = file_save_proc;
	impl->m_FileMenu[2].text = "Save &as...\tF12";
	impl->m_FileMenu[2].proc = file_saveas_proc;
	impl->m_FileMenu[3].text = "E&xit\tEsc";
	impl->m_FileMenu[3].proc = file_exit_proc;

	int numMethods = CApplication::getInstance ().numMethods ();
//	g_MethodsMenu = new MENU[numMethods+1];
	g_MethodsMenu = new MENU[21];
	impl->m_MethodsMenu = g_MethodsMenu;
//	impl->m_MethodsMenu = new MENU[numMethods+1];
	for (int i=0; i<numMethods+1; i++)
	{
		impl->m_MethodsMenu[i].text = 0;
		impl->m_MethodsMenu[i].proc = 0;
		impl->m_MethodsMenu[i].child = 0;
		impl->m_MethodsMenu[i].flags = 0;
		impl->m_MethodsMenu[i].dp = 0;
	}

	for (int i=0; i<numMethods; i++)
	{
		impl->m_MethodsMenu[i].text = CApplication::getInstance ().methodName (i);
	}

	impl->m_MethodsMenu[0].flags = D_SELECTED;

	impl->m_MethodsMenu[0].proc = method00_menu_proc;
	impl->m_MethodsMenu[1].proc = method01_menu_proc;
	impl->m_MethodsMenu[2].proc = method02_menu_proc;
	impl->m_MethodsMenu[3].proc = method03_menu_proc;
	impl->m_MethodsMenu[4].proc = method04_menu_proc;
	impl->m_MethodsMenu[5].proc = method05_menu_proc;
	impl->m_MethodsMenu[6].proc = method06_menu_proc;
	impl->m_MethodsMenu[7].proc = method07_menu_proc;
	impl->m_MethodsMenu[8].proc = method08_menu_proc;
	impl->m_MethodsMenu[9].proc = method09_menu_proc;
	impl->m_MethodsMenu[10].proc = method10_menu_proc;
	impl->m_MethodsMenu[11].proc = method11_menu_proc;
	impl->m_MethodsMenu[12].proc = method12_menu_proc;
	impl->m_MethodsMenu[13].proc = method13_menu_proc;
	impl->m_MethodsMenu[14].proc = method14_menu_proc;
	impl->m_MethodsMenu[15].proc = method15_menu_proc;
//	impl->m_MethodsMenu[16].proc = method16_menu_proc;
//	impl->m_MethodsMenu[17].proc = method17_menu_proc;
//	impl->m_MethodsMenu[18].proc = method18_menu_proc;
//	impl->m_MethodsMenu[19].proc = method19_menu_proc;
//	impl->m_MethodsMenu[20].proc = method20_menu_proc;

	impl->m_MainMenu = new MENU[4];
	impl->m_MainMenu[0].text	= "&File";
	impl->m_MainMenu[0].proc	= 0;
	impl->m_MainMenu[0].child	= impl->m_FileMenu;
	impl->m_MainMenu[0].flags	= 0;
	impl->m_MainMenu[0].dp		= 0;

	impl->m_MainMenu[1].text	= "&Methods";
	impl->m_MainMenu[1].proc	= 0;
	impl->m_MainMenu[1].child	= impl->m_MethodsMenu;
	impl->m_MainMenu[1].flags	= 0;
	impl->m_MainMenu[1].dp		= 0;

	impl->m_MainMenu[2].text	= "&About";
	impl->m_MainMenu[2].proc	= about_proc;
	impl->m_MainMenu[2].child	= 0;
	impl->m_MainMenu[2].flags	= 0;
	impl->m_MainMenu[2].dp		= 0;

	impl->m_MainMenu[3].text	= 0;
	impl->m_MainMenu[3].proc	= 0;
	impl->m_MainMenu[3].child	= 0;
	impl->m_MainMenu[3].flags	= 0;
	impl->m_MainMenu[3].dp		= 0;

	impl->m_Dialog = new DIALOG[5];
	impl->m_Dialog[0].proc  = d_menu_proc;
	impl->m_Dialog[0].x     = 0;
	impl->m_Dialog[0].y     = 0;
	impl->m_Dialog[0].w     = 0;
	impl->m_Dialog[0].h     = 0;
	impl->m_Dialog[0].fg    = gui_fg_color;
	impl->m_Dialog[0].bg    = gui_bg_color;
	impl->m_Dialog[0].key   = 0;
	impl->m_Dialog[0].flags = D_EXIT;
	impl->m_Dialog[0].d1    = 0;
	impl->m_Dialog[0].d2    = 0;
	impl->m_Dialog[0].dp    = impl->m_MainMenu;
	impl->m_Dialog[0].dp2   = 0;
	impl->m_Dialog[0].dp3   = 0;

	impl->m_Dialog[1].proc	= d_refresh_button_proc;
	impl->m_Dialog[1].x	= 540;
	impl->m_Dialog[1].y	= 450;
	impl->m_Dialog[1].w	= 80;
	impl->m_Dialog[1].h	= 20;
	impl->m_Dialog[1].fg	= gui_fg_color;
	impl->m_Dialog[1].bg	= gui_bg_color;
	impl->m_Dialog[1].key	= 'z';
	impl->m_Dialog[1].flags	= D_EXIT;
	impl->m_Dialog[1].d1	= 0;
	impl->m_Dialog[1].d2	= 0;
	impl->m_Dialog[1].dp	= (void*)"&Zoom";
	impl->m_Dialog[1].dp2	= 0;

	impl->m_Dialog[2].proc	= d_textbox_proc;
	impl->m_Dialog[2].x	= 10;
	impl->m_Dialog[2].y	= 400;
	impl->m_Dialog[2].w	= 120;
	impl->m_Dialog[2].h	= 20;
	impl->m_Dialog[2].fg	= gui_fg_color;
	impl->m_Dialog[2].bg	= gui_bg_color;
	impl->m_Dialog[2].key	= 0;
	impl->m_Dialog[2].flags	= 0;
	impl->m_Dialog[2].d1	= 0;
	impl->m_Dialog[2].d2	= 0;
	impl->m_Dialog[2].dp	= (void*)"Scale factor:";
	impl->m_Dialog[2].dp2	= 0;
	impl->m_Dialog[2].dp3	= 0;
	impl->m_Dialog[2].dp3	= 0;

	strcpy (g_ScaleString, "2.0000");
	impl->m_Dialog[3].proc	= d_edit_proc;
	impl->m_Dialog[3].x	= 130;
	impl->m_Dialog[3].y	= 405;
	impl->m_Dialog[3].w	= 100;
	impl->m_Dialog[3].h	= 20;
	impl->m_Dialog[3].fg	= gui_fg_color;
	impl->m_Dialog[3].bg	= gui_bg_color;
	impl->m_Dialog[3].key	= 0;
	impl->m_Dialog[3].flags	= 0;
	impl->m_Dialog[3].d1	= 32;
	impl->m_Dialog[3].d2	= strlen (g_ScaleString);
	impl->m_Dialog[3].dp	= g_ScaleString;
	impl->m_Dialog[3].dp2	= 0;
	impl->m_Dialog[3].dp3	= 0;

	int index = 4;
	impl->m_Dialog[index].proc  = 0;
	impl->m_Dialog[index].x     = 0;
	impl->m_Dialog[index].y     = 0;
	impl->m_Dialog[index].w     = 0;
	impl->m_Dialog[index].h     = 0;
	impl->m_Dialog[index].fg    = 0;
	impl->m_Dialog[index].bg    = 0;
	impl->m_Dialog[index].key   = 0;
	impl->m_Dialog[index].flags = 0;
	impl->m_Dialog[index].d1    = 0;
	impl->m_Dialog[index].d2    = 0;
	impl->m_Dialog[index].dp    = 0;
}


CImage CGui::getSourceImage () const
{
	if (NULL == g_SrcImage)
	{
		alert ("Error!", "no image in source bitmap!", 0, "OK", 0, 13, 27);
		throw "Ooops";
		return CImage (0, 0);
	}

	CImage	source (g_SrcImage->w, g_SrcImage->h);

	utils::extractR (source.getR (), g_SrcImage);
	utils::extractG (source.getG (), g_SrcImage);
	utils::extractB (source.getB (), g_SrcImage);
	utils::extractH (source.getH (), g_SrcImage);
	utils::extractS (source.getS (), g_SrcImage);
	utils::extractV (source.getV (), g_SrcImage);

	return source;
}



double CGui::getScaleFactor () const
{
	return atof (g_ScaleString);
}



void CGui::setDestination (CImage &img, bool rgb)
{
	g_DestImage = create_bitmap_ex (32, img.width (), img.height ());

	if (rgb)
		utils::composeImageFromRGB (g_DestImage, img);
	else
		utils::composeImageFromHSV (g_DestImage, img);

//	drawDestination ();
}


static void drawSource ()
{
	scare_mouse ();
	blit (g_SrcImage, screen, 0, 0, 50, 100, g_SrcImage->w, g_SrcImage->h);
	unscare_mouse ();
}


static void drawDestination ()
{
#ifdef DYRKI_EXT_VIEW
	if (!drawOutside (g_DestImage, "none")) return;
#endif
	scare_mouse ();
	blit (g_DestImage, screen, 0, 0, 250, 100, g_DestImage->w, g_DestImage->h);
	unscare_mouse ();
}



/*
===========================
    This is an unfortunate hacky decision i had to make in order to
 get stupid Allegro callback functions work. The point is that i need
 to know which of the callback functions was called. The only way to know
 it is to have this shit. I could make this with preprocessor magic,
 but had no time. maybe in later version :)

  -rtfb

===========================
*/


int method00_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[0].flags = D_SELECTED;

	return D_O_K;
}




int method01_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[1].flags = D_SELECTED;

	return D_O_K;
}




int method02_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[2].flags = D_SELECTED;

	return D_O_K;
}




int method03_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[3].flags = D_SELECTED;

	return D_O_K;
}




int method04_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[4].flags = D_SELECTED;

	return D_O_K;
}




int method05_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[5].flags = D_SELECTED;

	return D_O_K;
}




int method06_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[6].flags = D_SELECTED;

	return D_O_K;
}




int method07_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[7].flags = D_SELECTED;

	return D_O_K;
}




int method08_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[8].flags = D_SELECTED;

	return D_O_K;
}




int method09_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[9].flags = D_SELECTED;

	return D_O_K;
}




int method10_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[10].flags = D_SELECTED;

	return D_O_K;
}




int method11_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[11].flags = D_SELECTED;

	return D_O_K;
}




int method12_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[12].flags = D_SELECTED;

	return D_O_K;
}




int method13_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[13].flags = D_SELECTED;

	return D_O_K;
}




int method14_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[14].flags = D_SELECTED;

	return D_O_K;
}




int method15_menu_proc ()
{
	for (int i=0; 0!=g_MethodsMenu[i].text; i++)
	{
		g_MethodsMenu[i].flags = 0;
	}

	g_MethodsMenu[15].flags = D_SELECTED;

	return D_O_K;
}
