

#ifndef __GUI_H_RTFB__
#define __GUI_H_RTFB__


struct DIALOG;		// forward declaration
struct ALLEGRO_BITMAP;	// forward declaration
class CImage;		// forward declaration


/**
 * \class CGui gui.h gui.h
 * \author Vytautas Shaltenis, a.k.a. rtfb
 * \date 2002 12 12
 * \version 1.1
 *
 * A Graphical User Interface frontend for our application.
 * Don't get confused by the _pimpl idiom. I use it here not to let
 * Allegro stuff leak into header files. And anyway, reducing
 * dependencies never hurts :)
 *
 * \note Actually, the _pimpl idiom is used here because of an unfortunate
 * incompatibility of Allegro library and GNU ISO C++ library v. 3.2
 * included with MinGW32 v. 2.0 that we use.
 *
 * \note This class is used internally by \ref CApplication, so don't
 * pay too much attention trying to study the internals :)
 */
class CGui
{
public:
	CGui ();
	~CGui ();

	int doDialog ();

	double getScaleFactor () const;
	CImage getSourceImage () const;
	void setDestination (CImage &img, bool rgb);
	void initMenus ();

private:
	struct	SImpl;
	SImpl	*impl;
};

#endif		// #ifndef __GUI_H_RTFB__
