
#include "mmgr.h"

#include "image.h"

/*	SInternalLayer
 * Raw representation of CImage. Use with caution!
 * Use it only for fast mathematical calculations, not for
 * image storing/loading/copying/etc. That's what CImage
 * is for.
 */
CImage::SInternalLayer::~SInternalLayer ()
{
	for (int i=0; i<w; i++)
		delete[] data[i];

	delete[] data;
}

/*
CImage::SInternalLayer::SInternalLayer () : w (0), h(0), data (0)
{
}*/


CImage::SInternalLayer::SInternalLayer (int nw, int nh) :
	w (nw), h (nh), data (0)
{
	data = new (double*)[nw];

	for (int i=0; i<w; i++)
		data[i] = new double[nh];
}


CImage::SInternalLayer::SInternalLayer (const CImage::SInternalLayer &src) :
	w (src.w), h (src.h), data (0)
{
	data = new (double*)[w];

	for (int i=0; i<w; i++)
	{
		data[i] = new double[h];

		for (int j=0; j<h; j++)
			data[i][j] = src.data[i][j];
	}
}


SLayer& CImage::SInternalLayer::operator= (const CImage::SInternalLayer &src)
{
	if (data!=src.data)
	{
		if (0!=data)
		{
			for (int i=0; i<w; i++)
				delete[] data[i];

			delete[] data;
		}

		w = src.w;
		h = src.h;
		data = new (double*)[w];

		for (int i=0; i<w; i++)
		{
			data[i] = new double[h];

			for (int j=0; j<h; j++)
				data[i][j] = src.data[i][j];
		}
	}

	return *this;
}


CImage::CImage (int w, int h) :
	m_Width (w), m_Height (h), m_R (w, h), m_G (w, h), m_B (w, h),
	m_H (w, h), m_S (w, h), m_V (w, h)
{
}


CImage::CImage (const CImage &src) :m_R (src.m_R), m_G (src.m_G), m_B (src.m_B)
				    , m_H (src.m_H), m_S (src.m_S), m_V (src.m_V)
				    , m_Width (src.m_Width), m_Height (src.m_Height)
{
}

CImage& CImage::operator= (const CImage &src)
{
	if (this!=&src)
	{
		m_R = src.m_R;
		m_G = src.m_G;
		m_B = src.m_B;
		m_H = src.m_H;
		m_S = src.m_S;
		m_V = src.m_V;
		m_Width = src.m_Width;
		m_Height = src.m_Height;
	}

	return *this;
}

CImage::~CImage ()
{
}
