#ifndef __DIFF_WRAP_H__
#define __DIFF_WRAP_H__

#include "../method.h"

#include <string>
#include <iostream>


class CImage;		// forward declaration


class CDiffMethod :public IMethod
{
public:
	CDiffMethod () :IMethod ()
	{
		std::cout << "CDiffMethod" << std::endl;
	}

	~CDiffMethod ()
	{
		std::cout << "~CDiffMethod" << std::endl;
	}

	/**
	 * This function implements an interface implied in IMethod and it
	 * returns the name of the method.
	 */
	char* name () const
	{
		static char the_name[] = "Diffs";
		return the_name;
	}

	/**
	 * This function tells application if this method works with RGB
	 * or HSV. I this particular case, DDA algorithm works with RGB.
	 */
	const bool isRgb () const { return true; }


	bool process (CImage &dest, CImage &src);

private:
};

#endif		
