/** \file pmData.cpp
    \author Robertas Dumpis
    \date 2002 11 12
    \version 1.2
    \brief Some utilities for memory management and image storing
    These utilities is used only by \ref diffr, \ref SimplePeak and \ref ScaleEdge.
*/

#ifndef PMDATA_H
#define PMDATA_H

#define PMDATA_VER "1.2.0-STABLE"

#include "pTypes.h"
#ifdef PEAK_ALONE
#include "gen_bitmap.h"
#endif

#include "../image.h"

dot **alloc_btm(indx w, indx h);
void free_btm(dot **tmp, indx h);
dot **cpy_btm(dot **src, indx w, indx h);

//skirta sudiferenc. image'o datai transportuoti
struct mData {
    bool HSV;
	bool ErrTag;
    indx width, height;
    dot **red, **green, **blue;
    dot **hue, **sat, **value;
	void MDErr(const char *c);
    void MDErr();
    mData(indx w, indx h);
    mData(mData *src); 
#ifdef PEAK_ALONE
    mData(GBitmap *some);
#endif
    mData(CImage &some);    
    ~mData();  
#ifdef PEAK_ALONE
    GBitmap *exportImg(); 
#endif
    void exportImg(CImage &some);    
  };

#endif
