
#ifndef SCALE_EDGE_H
#define SCALE_EDGE_H

#define SCALE_EDGE_VER "1.0.4-STABLE"

#include "dfrn_lib.h"
#include "pmData.h"
#include "pTypes.h"
#include "../image.h"

/** \class ScaleEdge scale_edge.h scale_edge.h
    \author Robertas Dumpis
    \date 2002 11 18
    \version 1.0
    \brief A class, that implements scaling algorithm, based on edge detection (\ref diffr)
    This algorithm uses \ref diffr to find edges on the image, then sharpens the edges 
    while bluring other areas. 
*/

class ScaleEdge {
    private:
        mData *src, *dst;       //image'ai
        diffr *diff;            //source img differ.
        indx dCX, dCY;          /* current processing source dot (x, y)
                                   in this dot's environment required dest. dot is */
        indx dDX, dDY;          /* neighbours of current dest dot in src. image */
        indx dRX, dRY;          /* shows what diff's are to be used */
        double lX, lY, factorX, factorY;
        bool usingMD;           /* ar naudojame ishorini mData */
        indx widthS, heightS, widthD, heightD;  //imgs size
        bool SEErrTag;
        double koefT;
        void doThings();
        inline dot countValue(dot **layer, dot **diffX, dot **diffY, indx wD, indx hD);
        inline void getE(indx wD, indx hD);
        inline indx findNeighs(indx base, indx w, indx maxl, double factor);
        inline dot weight(dot s1, dot s2, dot df, double l);
//        inline double transf(dot df, double l);
        inline dot fin221(dot x, dot y);
        void SEErr(const char *c);
        void SEErr();

    public:
        ScaleEdge(CImage &some, CImage &dome, double koefT);
        ScaleEdge(mData *some, indx w, indx h, double koefT);
        ~ScaleEdge();
        void exportScale(CImage &dst);
        mData *exportScale();
        mData *getScale();
        bool getErr() { return SEErrTag; };
};

#endif
