
#ifndef __METHOD_MAKER_H_RTFB__
#define __METHOD_MAKER_H_RTFB__

//#include "method.h"
//#include <iostream>


class IMethod;		// forward declaration


/**
 * \class CMethodMaker method_maker.h ./pf/method_maker.h
 * \author Vytautas Shaltenis, a.k.a. rtfb
 * \date 2002 11 22
 * \version 1.0a
 *
 * This is a should-be-Pluggable-Factory class from which all the concrete
 * method makers should inherit. In this version there's no Pluggable Factory
 * and every concrete method should register by hand in \ref CApplication::collectMethods,
 * but the interface is stable and if PF is going to be implemented, the conversion
 * will be almos effortless.
 */
class CMethodMaker
{
protected:
	CMethodMaker ()
	{
//		std::cout << "CMethodMaker" << std::endl;
	}

	virtual ~CMethodMaker ()
	{
//		std::cout << "~CMethodMaker" << std::endl;
	};

	static IMethod* makeMethod ();
};

#endif		// #ifndef __METHOD_MAKER_H_RTFB__
