#include <vector>
#include <iostream>

#include "mmgr.h"

#include "curves_neural.h"
#include "layer.h"
#include "network.h"

using namespace std;


ccurve_neural_2d::ccurve_neural_2d()
 :net (0), bufsize (0)
{
}/*
*/

ccurve_neural_2d::ccurve_neural_2d(SLayer &l, int scanln, bool isVert)
{
	construct(l, scanln, isVert);
}

ccurve_neural_2d::~ccurve_neural_2d()
{
	destruct();
}

void
ccurve_neural_2d::construct(SLayer &l, int scanln, bool isVert)
{
	vector<double> inputs;
	vector<double> outputs;
	
	double error_tollerance = 10.0/256.0; // per pixel
	double max_input =  4.0;
	double min_input = -4.0;
	double max_output = 0.9;
	double min_output = 0.1;
	int iterations = 1000;
	
	inputs.push_back(0.0);
	outputs.push_back(0.0);
	if (isVert)
	{
		bufsize = l.w;
		double error=500;
		
		while (error>bufsize*error_tollerance)
		{
		    net = new neural_network(1,10,25,1);
		    for (int i=0; ((i<iterations) && (error>bufsize*error_tollerance));i++)
			{
				error=0.0;
				if (i%100==0) cout << i << " ";
				for (int x=0; x<bufsize; x++)
				{
					inputs[0]=(max_input-min_input)*((double)x/(double)bufsize)+min_input;
					outputs[0]=(max_output-min_output)*l.data[x][scanln]+min_output;
					error += net->batch_pattern(inputs,outputs);
				}
				net->train();
				net->clear();
				if (i%100==0) cout << error << endl;
		    }
			cout << error << endl;
 		    if (error>bufsize*error_tollerance) delete net;
		}
	}
	else
	{
		bufsize = l.h;
		double error=500;
		
		while (error>bufsize*error_tollerance)
		{
		    net = new neural_network(1,10,25,1);
		    for (int i=0; ((i<200) && (error>bufsize*error_tollerance));i++)
		    {
				error=0.0;
				if (i%100==0) cout << i << " ";
				for (int x=0; x<bufsize; x++)
				{
					inputs[0]=(max_input-min_input)*((double)x/(double)bufsize)+min_input;
					outputs[0]=(max_output-min_output)*l.data[scanln][x]+min_output;
					error += net->batch_pattern(inputs,outputs);
				}
				net->train();
				net->clear();
				if (i%100==0) cout << error << endl;
		    }	
			cout << error << endl;
		    if (error > bufsize*error_tollerance) delete net;
		}
	}
}

void
ccurve_neural_2d::destruct()
{
	if (0 != net)
		delete net;

	bufsize = 0;
}

double
ccurve_neural_2d::get_value (double x)
{
	return (net->get_output(x)-0.05)/0.9;
}
