
#include "nommgr.h"
#include <vector>
#include "mmgr.h"
using namespace std;

class c_layer
{
public:
	c_layer(int neuron_count);
	~c_layer();
	void connect(c_layer *previous_layer);
	void set_outputs(vector<double> data);
	void forward();

	double calculate_error(vector<double> target);
	void backward();

	void batch();

	void update();
	void clear();
	
	double function(double param);
	double fderivative(double param);
	double get_output();
private:
	vector<double *>	errors;
	vector<double *>	sum_of_errors;
	vector<double *>	previous_layer_errors;
	vector<double *>	sum_of_previous_layer_errors;
	vector<double *>	inputs;
	vector<double *>	outputs;
	vector<double>		weights;
	vector<double>		deltas;
	vector<double>		derivatives;
	vector<double>		previous_iteration_derivatives;
	int 			neuron_count;
	int			previous_layer_neuron_count;
};
