
#ifndef __CMETHOD_NEURAL_H__QZ__
#define __CMETHOD_NEURAL_H__QZ__

#include "../method.h"

#include "../yvl/curve_3dfrom2d.h"


/**
 * Main Method interface
 *
 * The very basic, but vital interface for any method that is to be implemented
 * in Igrovod.
 */
class CMethodNeural : public IMethod
{
private:
	int x;
	ccurve_3drgb	*imgproc;

public:
	CMethodNeural ();

	virtual ~CMethodNeural ();

	virtual bool process (CImage &dest, CImage &src);

	char* name () const
	{
		static char the_name[] = "Neural Networks";
		return the_name;
	}

	virtual const bool isRgb () const { return true; };
};

#endif		// #ifndef __CMETHOD_NEURAL_H__QZ__
