
#include "nommgr.h"
#include <vector>
#include "mmgr.h"
using namespace std;

class c_layer;

typedef std::vector<c_layer *> Container;
typedef Container::iterator Iter;
typedef Container::reverse_iterator RIter;

class neural_network
{
public:
	neural_network(int input_count,int hidden_layer_neuron_count,
			int hidden_layer_count,int output_count);
	neural_network(int hidden_layer_count);
	~neural_network();

	double train_pattern(vector<double> inputs,vector<double> outputs);
	double train_pattern(double x,double y,double value);

	double batch_pattern(vector<double> inputs,vector<double> outputs);
	double batch_pattern(double x,double y,double value);
	void train();
	void clear();
	
	double get_output(double x,double y);
	double get_output(double x);
private:
	Container layers;
	neural_network();
};
