
#include <math.h>
#include "curves_sin.h"
#include <malloc.h>
#include "../mmgr.h"

ccurve_sin_2d::ccurve_sin_2d()
{
	buf = 0;
	bufsize = 0;
}

ccurve_sin_2d::ccurve_sin_2d(SLayer &l, int scanln, bool isVert)
{
	construct(l, scanln, isVert);
}

ccurve_sin_2d::~ccurve_sin_2d()
{
	destruct();
}

void
ccurve_sin_2d::construct(SLayer &l, int scanln, bool isVert)
{
	if (isVert)
	{
		bufsize = l.w;
		buf = new (double)[bufsize];
		for (int x=0; x<bufsize; x++) buf[x] = l.data[x][scanln];
	}
	else
	{
		bufsize = l.h;
		buf = new (double)[bufsize];
		for (int y=0; y<bufsize; y++) buf[y] = l.data[scanln][y];
	}
}

void
ccurve_sin_2d::destruct()
{
	if (buf) delete[] buf;
	buf = 0;
	bufsize = 0;
}

double
ccurve_sin_2d::get_value (double x)
{
//	if (x==1.0f) return buf[bufsize-1];
	x*=bufsize-2;
	int pos = (int)(x);
	double a = buf[pos];
	double b = buf[pos+1];
	double X = x-pos;
	double ft = X * 3.14159265;
	double f = (1-cos(ft)) * .5;
	return a*(1-f) + b * f;
}



