
#ifndef __CMETHOD_SIN_H__QZ__
#define __CMETHOD_SIN_H__QZ__

#include "../method.h"

#include "../yvl/curve_3dfrom2d.h"

#include <string>


/**
 * Main Method interface
 *
 * The very basic, but vital interface for any method that is to be implemented
 * in Igrovod.
 */
class CMethodSin : public IMethod
{
private:
	int x;
	ccurve_3drgb	*imgproc;

public:
	CMethodSin ();

	virtual ~CMethodSin ();

	virtual bool process (CImage &dest, CImage &src);

	char* name () const { static char *mname = "Sin (QZ)"; return mname; }

	virtual const bool isRgb () const { return true; };

};

#endif		// #ifndef __CMETHOD_SIN_H__QZ__
