
#include "curve_3dfrom2d.h"
#include <malloc.h>
#include <iostream>
#include "../mmgr.h"

ccurve_3drgb::ccurve_3drgb()
{
	c2d = 0;
	buf = 0;
}

ccurve_3drgb::ccurve_3drgb(ccurve_2d *c2)
{
	c2d = c2;
	buf = 0;
}

ccurve_3drgb::~ccurve_3drgb()
{
	if (c2d) delete c2d;
	if (buf) delete buf;
}

void
ccurve_3drgb::construct(SLayer &l)
{
//	std::cout << "construct" <<std::endl;
	buf = new SLayer(l);
//	std::cout << "construct ok" <<std::endl;
}

void
ccurve_3drgb::destruct()
{
//	std::cout << "destruct" <<std::endl;
	if (buf) delete buf;
//	std::cout << "destruct ok" <<std::endl;
}


void
ccurve_3drgb::get_layer(SLayer &l)
{
	if (!c2d) return;
	SLayer	nubuf(l.w, buf->h);

	for(int y=0;y<buf->h;y++)
	{
		c2d->reconstruct(*buf, y, true);
		c2d->get_layer(nubuf, y, true);
	}

	for(int x=0;x<l.w;x++)
	{
		c2d->reconstruct(nubuf, x, false);
		c2d->get_layer(l, x, false);
	}
}




