
#include "curve_3dfrom2d_furje.h"
#include "curves_linear.h"
#include <malloc.h>
#include <iostream>
#include "../mmgr.h"


ccurve_3dfurje::ccurve_3dfurje()
{
	c2d = 0;
	this->buf = 0;
}

ccurve_3dfurje::ccurve_3dfurje(ccurve_2d *c2)
{
	c2d = c2;
	this->buf = 0;
}

ccurve_3dfurje::~ccurve_3dfurje()
{
	if (c2d) delete c2d;
	if (buf) delete this->buf;
}

void
ccurve_3dfurje::construct(SLayer &l)
{
//	std::cout << "construct called from curve_3dfrom2d_furje.cc" << std::endl;
	buf = new SLayer(l);
}

void
ccurve_3dfurje::destruct()
{
	if (buf) delete buf;
}


void
ccurve_3dfurje::get_layer(SLayer &l)
{
//	std::cout << "get_layer called from curve_3dfrom2d_furje.cc" << std::endl;
	if (!c2d) return;

	SLayer	dblbuf(buf->w*2, buf->h);


	for (int y=0; y<buf->h; y++)
		for (int x=0; x<buf->w; x++)
		{
			dblbuf.data[x][y] = buf->data[x][y];
			dblbuf.data[dblbuf.w-x-1][y] = 1 - buf->data[x][y];
		}


	SLayer	nubuf(l.w, dblbuf.h);

	std::cout << "Processing layer..." << std::endl;

	for(int y=0;y<buf->h;y++)
	{
		c2d->reconstruct(dblbuf, y, true);
		std::cout << ".";
		c2d->get_layer(nubuf, y, true);
	}

	SLayer	dblnubuf(l.w, dblbuf.h*2);

	for (int y=0; y<nubuf.h; y++)
		for (int x=0; x<nubuf.w; x++)
		{
			dblnubuf.data[x][y] = nubuf.data[x][y];
			dblnubuf.data[x][dblnubuf.h-y-1] = 1 - nubuf.data[x][y];
		}


	for(int x=0;x<l.w;x++)
	{
		c2d->reconstruct(dblnubuf, x, false);
		c2d->get_layer(l, x, false);
		std::cout << ".";
	}
		std::cout << "...done"<<std::endl;

}




