
#include "curves2d_furje.h"
#include <malloc.h>
#include <math.h>
#include <iostream>
#include "../mmgr.h"

	double		MYPI = 3.141592;
	double		FREQUENCY = 256;


ccurve_furje_2d::ccurve_furje_2d(int koefcount)
{
	m_koefcount = koefcount;
	m_koefc = new (double)[koefcount];
	m_koefs = new (double)[koefcount];
	amp = 0;
	pshift = 0;
}

ccurve_furje_2d::ccurve_furje_2d(SLayer &l, int scanln, bool isVert, int koefcount)
{
	m_koefcount = koefcount;
	m_koefc = new (double)[koefcount];
	m_koefs = new (double)[koefcount];
	construct(l, scanln, isVert);
}

ccurve_furje_2d::~ccurve_furje_2d()
{
	destruct();
	delete[] m_koefc;
	delete[] m_koefs;
}

void
ccurve_furje_2d::construct(SLayer &l, int scanln, bool isVert)
{
//	std::cout << "scanline" << scanln << std::endl;
	int		NumEl;

	if (isVert) NumEl = l.w;
		else  NumEl = l.h;

	int		NumSins = (NumEl/2+1);
/*	double		C[NumEl][NumSins][2];
	for (int n=0; n<NumSins; n++)
	{
		for (int e=0; e<NumEl; e++)
		{
//			double	DC = ;
//			double	FEN = n * FREQUENCY / NumEl;
			double	DN = 2 * MYPI * n * e / NumEl;
			C[e][n][0] = cos(DN);
			C[e][n][1] = -sin(DN);
		}
	}
*/
//	double		B[NumSins];
//	B[0] = ((double)1)/NumEl;
//	for (int n=1; n<NumEl/2; n++) B[n] = ((double)2)/NumEl;
//	B[NumEl/2] = ((double)1)/NumEl;


	double		*ResCos, *ResSin;
	double		B;
	ResCos = new double[NumSins];
	ResSin = new double[NumSins];

	for (int n=0; n<NumSins; n++)
	{
		ResCos[n] = 0;
		ResSin[n] = 0;

//		if ((n==0)or(n==NumSins-1)) B = ((double)1)/NumEl;
		if ((n==0)||(n==NumSins-1)) B = ((double)1)/NumEl;
			else B = ((double)2)/NumEl;

		if (isVert)
		{
			for (int e=0; e<NumEl; e++)
			{
				double	DN = 2 * MYPI * n * e / NumEl;
				ResCos[n] += double (l.data[e][scanln]-0.5)*B*cos(DN);
				ResSin[n] += double (l.data[e][scanln]-0.5)*B*(-sin(DN));
			}
		}
		else
		for (int e=0; e<NumEl; e++)
		{
			double	DN = 2 * MYPI * n * e / NumEl;
			ResCos[n] += double (l.data[scanln][e]-0.5)*B*cos(DN);
			ResSin[n] += double (l.data[scanln][e]-0.5)*B*(-sin(DN));
		}
	}

	this->amp = new double[NumSins];
	this->pshift = new double[NumSins];
	this->sincount = NumSins;
	for (int n=0; n<NumSins; n++)
	{
//		amp[n] = Res[n][0];
		amp[n] = sqrt(ResCos[n]*ResCos[n]+ResSin[n]*ResSin[n]); // ????????????

//		amp[n] = Res[n][0]*Res[n][0]+Res[n][1]*Res[n][1]; // ????????????
//		amp[n] *= amp[n];
		pshift[n] = 0;
		if (-ResSin[n] == 0)
		{
			pshift[n] = MYPI / 2;
			if (ResCos[n] < 0) pshift[n] = -pshift[n];
		}
		else
		{
			pshift[n] = atan( ResSin[n] / (-ResSin[n]));
			if (ResSin[n] > 0) pshift[n] += MYPI;
		}
//		std::cout << "amp[" << n << "]=" << amp[n] << "; pshift = " << pshift[n] << std::endl;
//		std::cout << "Res1[" << n << "]=" << Res[n][1] << "; Res2 = " << Res[n][2] << std::endl;
	}
// PRINT N * FE / NE; "HZ A="; A; " D="; D
	delete[] ResCos;
	delete[] ResSin;


}

void
ccurve_furje_2d::destruct()
{
	if (amp) delete[] amp;
	if (pshift) delete[] pshift;
}


double
ccurve_furje_2d::get_value(double x)
{

	double Wn = 0;
	for(int n=0; n<sincount-1; n++)
	{
		Wn += amp[n]*sin(MYPI*n*x+pshift[n]+MYPI/4);
	}
	Wn+=0.5;
	if (Wn>1) Wn = 1;
	if (Wn<0) Wn = 0;
	return Wn;

}



