
#include "generic_curves.h"
#include <malloc.h>

#include <iostream>
#include "../mmgr.h"

ccurve_2d::ccurve_2d()
{
}


void
ccurve_2d::reconstruct(SLayer &l, int scanln, bool isVert)
{
//	std::cout << "ccurve2d::reconstruct called " << std::endl;
//	std::cout << "calling destruct " << std::endl;
	destruct();
//	std::cout << "calling construct " << std::endl;
	construct(l, scanln, isVert);
}


ccurve_2d::~ccurve_2d()
{
}

double
ccurve_2d::get_value(double x)
{
	x = x;
	return 0.0f;
}

void
ccurve_2d::get_layer(SLayer &l, int scanln, bool isVert)
{
/*
	if (isVert)
		for (int x=0; x<l.w; x++)
			l.data[x][scanln] = get_value( ((double)x)/(l.w-1) );
	else
		for (int y=0; y<l.h; y++)
			l.data[scanln][y] = get_value( ((double)y)/(l.h-1) );
*/

	if (isVert)
		for (int x=0; x<l.w; x++)
			l.data[x][scanln] = 0;
	else
		for (int y=0; y<l.h; y++)
			l.data[scanln][y] = 0;

	if (isVert)
		for (int x=0; x<l.w*10; x++)
			l.data[x/10][scanln] += get_value( ((double)x)/(l.w*10-1) )/10;
	else
		for (int y=0; y<l.h*10; y++)
			l.data[scanln][y/10] += get_value( ((double)y)/(l.h*10-1) )/10;

}



ccurve_3d::ccurve_3d()
{
}

ccurve_3d::~ccurve_3d()
{
}


void
ccurve_3d::reconstruct(SLayer &l)
{
//	std::cout << "ccurve3d::reconstruct called " << std::endl;
//	std::cout << "calling destruct " << std::endl;
	destruct();
//	std::cout << "calling construct " << std::endl;
	construct(l);
//	std::cout << "ok" << std::endl;
}


double
ccurve_3d::get_value(double x, double y)
{
	x = x;
	y = y;
	return 0.0f;
}

void
ccurve_3d::get_layer(SLayer &l)
{
	for (int y=0; y<l.h; y++)
		for (int x=0; x<l.w; x++)
			l.data[x][y] = get_value( x/(l.w-1), y/(l.h-1) );
}


