
#ifndef _GENERIC_CURVES_H__
#define _GENERIC_CURVES_H__

#include "image.h"

// kreiviu v = f(x) tevine klase
class ccurve_2d
{
protected:
virtual	void		construct(SLayer &l, int scanln, bool isVert) = 0; // constructs curve
virtual	void		destruct() = 0; // destroys curve / frees memory if needed

public:

			ccurve_2d();
virtual			~ccurve_2d();

virtual	void		reconstruct(SLayer &l, int scanln, bool isVert);

virtual	double		get_value(double x);

virtual	void		get_layer(SLayer &l, int scanln, bool isVert);

};



// kreiviu v = f(x, y) tevine klase
class ccurve_3d
{
protected:
virtual	void		construct(SLayer &l) = 0; // constructs curve
virtual	void		destruct() = 0; // destroys curve / frees memory if needed
// x, y priklauso [0.0, 1.0] . 0.0 -- pradzhia, 1.0 -- galas.
// rezultatas irgi privalo priklausyt intervalui [0.0, 1.0]
virtual	double		get_value(double x, double y);

public:

			ccurve_3d();
virtual			~ccurve_3d();

// turetu issivalyti visus su kreive buvusius duomenis, ir sukurti nauja kreive.
virtual	void		reconstruct(SLayer &l);


// uzhpildo atminti, kur rodo buffer. kas ka reishkia turetu buti aishku ish constr. aprashymo
virtual	void		get_layer(SLayer &l);

};




#endif // _GENERIC_CURVES_H__
