
#ifndef __CMETHOD_LINEAR_H__YVL__
#define __CMETHOD_LINEAR_H__YVL__

#include "../method.h"

#include "curve_3dfrom2d.h"

#include <string>


/**
 * Main Method interface
 *
 * The very basic, but vital interface for any method that is to be implemented
 * in Igrovod.
 */
class CMethodLinear : public IMethod
{
private:
	int x;
	ccurve_3drgb	*imgproc;

public:
	CMethodLinear ();

	virtual ~CMethodLinear ();

	virtual bool process (CImage &dest, CImage &src);

	char* name () const { static char *mname = "Linear (YVL)"; return mname; }

	virtual const bool isRgb () const { return true; };

};

#endif		// #ifndef __CMETHOD_LINEAR_H__YVL__
